
#ifndef __DITHERING_H__
#define __DITHERING_H__

#include <stdint.h>             /* Wird für die uintX_t Datentypen benötigt */
#include <stdbool.h>            /* wird für den bool Datentyp benötigt */

/* Diesen Abschnitt bitte entsprechend anpassen */
#define DAC_RES_IN_BITS         8       /* Anzahl der Bits, die der reale DAC hat. */    
#define VREF_IN_MILLIVOLT       2048    /* Referenzspannung des DACs. MAX: 4.294.967.296 µV (4,294967296 V) wegen 32 Bit Datentyp */

/* Einfache Makros */
#define DAC_MAX_STEPS           ((uint32_t)(1<<DAC_RES_IN_BITS))    /* 2^RES - Schiften ist bei 2^X einfacher/schneller als POWs! */
#define DAC_1_STEP_IN_MICROVOLT ((uint32_t)(((uint32_t)VREF_IN_MILLIVOLT*1000u)/DAC_MAX_STEPS))    /* in Fixpoint umgerechnet! */

bool check_bit(uint16_t var, uint8_t bit_pos);
uint32_t calulate_dac_base_steps(uint32_t dac_output_in_microvolt);
uint8_t get_dither_sequence(void);
void fill_dac_value_table(uint16_t dac_base_value, uint8_t table_sequence);
uint16_t get_dithering_dac_value(uint8_t pos);
void clear_dithering_table(void);


#endif